<script setup>
import { NuxtLink } from "#components";
import jmespath from "jmespath";

import config from "~/lib/config";
import { parseFields } from "~/lib/parsing";

const route = useRoute();
const { data } = await useAsyncData(`studies/${route.params.id}`, () => {
  return queryContent("/studies").where({ id: route.params.id }).findOne();
});

watchEffect(() => {
  parseFields(data.value);
});

useHead({
  title: `${jmespath.search(data.value, config.detail.meta.title_path)}`,
  ...config.detail.head,
});

const getRDFaProps = (item) => ({
  property: item.rdfa?.property,
  content: item.rdfa?.content && jmespath.search(data.value, item.rdfa.content),
});

const apiUrl = `/api/v0/studies/${data.value.id}.json`;
</script>

<template>
  <div>
    <h1 class="title" v-bind="getRDFaProps(config.detail.heading)">
      {{ jmespath.search(data, config.detail.heading.path) }}
    </h1>

    <section class="section">
      <div class="level">
        <div
          class="level-item is-flex is-flex-direction-column"
          v-for="(item, idx) in config.detail.top"
          :key="idx"
        >
          <p class="heading is-size-6">{{ item.label }}</p>
          <component
            :is="item.href && jmespath.search(data, item.href) ? 'a' : 'div'"
            :href="item.href && jmespath.search(data, item.href)"
            target="_blank"
            rel="noopener noreferrer"
            class="is-flex-grow-1 is-flex is-flex-direction-column is-justify-content-center"
          >
            <component
              v-if="item.component"
              :is="resolveComponent(item.component)"
              :value="jmespath.search(data, item.path)"
              :class="{
                'is-large': ['StatusTag'].includes(item.component),
                'is-size-3': ['DateDisplay'].includes(item.component),
              }"
              v-bind="getRDFaProps(item)"
            />
            <span v-else class="is-size-3" v-bind="getRDFaProps(item)">
              {{ jmespath.search(data, item.path) }}
            </span>
          </component>
        </div>
      </div>
    </section>

    <section class="section">
      <template v-for="(panel, idx) in config.detail.panels">
        <article
          :key="idx"
          v-if="
            panel.fields
              .map((f) => jmespath.search(data, f.path))
              .reduce((a, b) => a || (b instanceof Array ? b.length : b), false)
          "
          class="message"
        >
          <div class="message-header">
            <p>{{ panel.label }}</p>
          </div>
          <div class="message-body">
            <div class="content">
              <template v-for="(field, idx) in panel.fields">
                <template
                  v-if="
                    (value = jmespath.search(data, field.path)) instanceof Array
                      ? value.length
                      : value
                  "
                >
                  <strong>{{ field.label }}</strong>
                  <ul v-if="field.is_list" class="mt-1">
                    <li
                      v-for="(item, idx) in jmespath.search(data, field.path)"
                      :key="idx"
                    >
                      <DetailItem
                        :type="field.type"
                        :value="item"
                        v-bind="getRDFaProps(field)"
                      />
                    </li>
                  </ul>
                  <p v-else class="mt-1">
                    <DetailItem
                      v-bind="getRDFaProps(field)"
                      :type="field.type"
                      :value="jmespath.search(data, field.path)"
                    />
                  </p>
                </template>
              </template>
            </div>
          </div>
        </article>
      </template>
    </section>

    <NuxtLink :to="apiUrl" target="_blank">View raw data</NuxtLink>
    <br />
  </div>
</template>
